# `ASY̎
# Authors:: fukuyama
# Date:: 2012/03/11
# Copyright:: Copyright (c) 2012 rgss-lib
# License:: BSD License

# `ASY
module AStarAlgorithm
  
  # m[hNX
  class Node
    MAX_SCORE = 32767
    
    attr_accessor :prev_node
    attr_accessor :cost
    attr_accessor :score
    
    # 
    def initialize
      @prev_node = nil
      @score = MAX_SCORE
      @cost = 0
    end
    
    # selfnode܂ł̋ij
    def distance(node)
      return MAX_SCORE
    end
    
    # ړ\H
    def passable?(node)
      return false
    end
    
    # אڃm[h̎擾
    def adjacency_nodes
      return []
    end
  end
  
  def self.search(start_node,gool_node,max_cost=Node::MAX_SCORE)
    # Xg
    open_nodes = []
    close_nodes = []
    
    # X^[gm[h̃XRAZo
    start_node.score = start_node.distance(gool_node)
    open_nodes.push start_node
    
    # Xgm[h
    last_node = nil
    
    # T[v
    while (not open_nodes.empty?)
      # ɌvZm[hԒႢXRÃm[hT
      open_nodes.sort! {|a,b| a.score <=> b.score}
      cnode = open_nodes.shift
      # S[m[hȂI
      if cnode == gool_node
        last_node = cnode
        break
      end
      
      # N[YXgɒǉ
      close_nodes.push cnode
      # אڃm[h擾
      cnode.adjacency_nodes.each do |anode| # אڃm[h
        next if open_nodes.include?(anode)  # oH
        next if close_nodes.include?(anode) # vZς
        next unless cnode.passable?(anode)  # ړs\
        # RXgOm[h܂ł̃RXg{P
        anode.cost = cnode.cost + 1
        # XRARXg{S[܂ł̋
        anode.score = anode.cost + anode.distance(gool_node)
        # אڃm[h̑Om[hݒ
        anode.prev_node = cnode
        # oHɒǉ
        open_nodes.push anode
      end
    end
    # T
    results = []
    while not last_node.nil?
      results.unshift last_node
      last_node = last_node.prev_node
    end
    return results
  end
  
end
