# DQbZ[WEBhE
# Authors:: fukuyama
# Date:: 2011/12/14
# Copyright:: Copyright (c) 2011 rgss-lib
# License:: BSD License

module DQ
  # EBhEXN[bZ[W(DQbZ[WEBhE)
  class Window_Scroll_Message < Window_Base
    # 
    def initialize(message_window)
      @message_window = message_window
      super(0, 0, @message_window.window_width, @message_window.window_height)
      self.z = message_window.z + 10
      self.opacity = 0
      self.arrows_visible = false
      clear_instance_variables
    end

    # EBhEe̍vZ
    def contents_height
      #@{EBhÊQ{ɂ
      super * 2
    end

    # CX^Xϐ̃NA
    def clear_instance_variables
      @pos = nil
      @text = ""
      @scroll_up = 0
      @scroll_speed = 2
    end

    # EBhEN[Y
    def close
      clear_instance_variables
      self.contents.clear()
      super
    end

    # EBhE̍XV
    def update
      super
    end

    # EBhËʒuXV
    def update_placement
      self.y = @message_window.y
    end

    # XN[̍XV
    def update_scroll
      # XN[
      if @scroll_up > 0 and (@pos[:ay] != self.oy)
        n = 0
        if @scroll_speed != 0
          n = @scroll_speed
          n = @scroll_up if @scroll_up < n
        else
          n = @pos[:height]
        end
        n = 1 if n <= 0
        @scroll_up -= n
        self.oy += n
        return true
      end
      if @pos[:ay] != self.oy
        # \͈͂𒴂ĂꍇA܂ŃXN[
        if (self.oy + @message_window.contents_height()) <= @pos[:y]
          @scroll_up = @pos[:height]
          return true
        end
        if @pos[:y] != @pos[:py]
          @scroll_up = @pos[:height]
          @pos[:py] = @pos[:y]
          return true
        end
      end
      return false
    end

    # y[W
    def new_page(text, pos)
      # ʒuۑ
      if @pos.nil?
        @pos = pos
      end
      if not pos[:ay].nil?
        process_all_text_end
        @pos[:y] = @pos[:height] * @message_window.visible_line_number
      end
      @text = text
      # \ʒu𒲐
      pos[:y] = @pos[:y] # Ŷݕۑ ݂̕\ʒu
      @pos = pos
      @pos[:ay] = @pos[:y]
      @pos[:py] = @pos[:y]
    end

    # Rec̏
    # XN[Ăꂽ\ʒu
    def contents_initialize
      # XN[rbg}bv̈ԏɂăXN[ʒu
      @scroll_up = 0
      r = self.contents.rect
      r.y = @pos[:ay]
      bmp = self.contents.dup
      self.contents.clear
      self.contents.blt(0, 0, bmp, r)
      self.oy = 0
      bmp.dispose
      @pos[:y] = @pos[:y] - @pos[:ay]
      @pos[:ay] = 0
      @pos[:py] = 0
    end

    #@ׂẴeLXgIƂ̏
    def process_all_text_end
      # \bZ[Wԏɗ悤ɃXN[
      @scroll_up = @pos[:ay] - self.oy
      while update_scroll
        Fiber.yield
      end
      # XN[IbZ[WSĕ\Ăꍇ
      # if @scroll_up <= 0 and @text.empty?
      contents_initialize()
      # end
    end

    # ʏ핶̏
    def process_normal_character(c, pos)
      # ɏĂ炤
      super
    end

    # 䕶̏
    def process_escape_character(code, text, pos)
      # EBhEŗL̐䕶ȊOicontentsɉê镨j͂łĂ炤
      super
    end

  end

  #@Window_MessagepW[
  module Window_Message_Module
    # ̏
    def process_character(c, text, pos)
      super
      while @window_scroll_message.update_scroll
        Fiber.yield
      end
    end

    # ʏ핶̏
    def process_normal_character(c, pos)
      @window_scroll_message.process_normal_character(c, pos)
    end

    # 䕶̏
    def process_escape_character(code, text, pos)
      @window_scroll_message.process_escape_character(code, text, pos)
    end

    # EBhEI[v
    def open
      # A
      @window_scroll_message.open
      super
    end

    # EBhEN[Y
    def close
      # A
      @window_scroll_message.close
      super
    end

    def z=(n)
      if not @window_scroll_message.nil?
        @window_scroll_message.z = @window_scroll_message.z - self.z + n
        @choice_window.z = n
        @number_window.z = n
        @item_window.z = n
      end
      super(n)
    end

    def input_force_pause
      Fiber.yield while $game_message.force_pause?
    end

    # \bhĒ`
    def self.included(klass)
      klass.module_eval <<-EVAL
      def process_input
        if $game_message.choice?
          input_choice
        elsif $game_message.num_input?
          input_number
        elsif $game_message.item_choice?
          input_item
        elsif $game_message.force_pause?
          input_force_pause
        else
          input_pause unless @pause_skip
        end
      end
      def need_new_page?(text, pos)
        pos[:y] - pos[:ay] >= contents.height && !text.empty?
      end
      alias :#{METHOD_PREFIX}process_all_text :process_all_text
      def process_all_text
        #{METHOD_PREFIX}process_all_text
        @window_scroll_message.process_all_text_end
      end
      alias :#{METHOD_PREFIX}new_page :new_page
      def new_page(text, pos)
        #{METHOD_PREFIX}new_page(text, pos)
        @window_scroll_message.new_page(text, pos)
      end
      alias :#{METHOD_PREFIX}update_placement :update_placement
      def update_placement
        #{METHOD_PREFIX}update_placement()
        @window_scroll_message.update_placement
      end
      alias :#{METHOD_PREFIX}create_all_windows :create_all_windows
      def create_all_windows
        @window_scroll_message = Window_Scroll_Message.new(self)
        #{METHOD_PREFIX}create_all_windows()
      end
      alias :#{METHOD_PREFIX}dispose_all_windows :dispose_all_windows
      def dispose_all_windows
        @window_scroll_message.dispose
        #{METHOD_PREFIX}dispose_all_windows()
      end
      alias :#{METHOD_PREFIX}update_all_windows :update_all_windows
      def update_all_windows
        @window_scroll_message.update
        #{METHOD_PREFIX}update_all_windows()
      end
      EVAL
    end
  end
end

class Window_Message
  include DQ::Window_Message_Module
end

class Game_Message
  attr_accessor :force_pause
  def force_pause?
    @force_pause
  end
end

class Game_Interpreter
  @@force_pause_codes = []
  #--------------------------------------------------------------------------
  #  ͂̕\
  #--------------------------------------------------------------------------
  def command_101
    wait_for_message
    $game_message.face_name = @params[0]
    $game_message.face_index = @params[1]
    $game_message.background = @params[2]
    $game_message.position = @params[3]
    while next_event_code == 401       # ̓f[^
      @index += 1
      $game_message.add(@list[@index].parameters[0])
    end
    case next_event_code
    when 102  # I̕\
      @index += 1
      setup_choices(@list[@index].parameters)
    when 103  # l͂̏
      @index += 1
      setup_num_input(@list[@index].parameters)
    when 104  # ACeȈ
      @index += 1
      setup_item_choice(@list[@index].parameters)
    else
      if @@force_pause_codes.include? next_event_code
        $game_message.force_pause = true
        return true
      end
    end
    wait_for_message
  end
end
