# VbvpCxgXNvg(Event_Script_Shop)
# Authors:: fukuyama
# Date:: 2012/05/03
# Copyright:: Copyright (c) 2012 rgss-lib
# License:: BSD License

module Event_Script
  module Shop
    CHOICE_VARIABLE = 'IACe'
    PRICE_VARIABLE = '̔i'
    PRICE_RATE_VARIABLE='̔i[g'

    # CEBhE
    @@window = nil

    # wACe
    @@item = nil

    # i
    @@price = 0

    module_function
    # 
    def buy
      n = 1
      actor = Event_Script::Buy_Actor_Select.actor
      if actor.nil?
        actor = $game_party
      end
      Item_Facade.gain(@@item,actor)
      $game_party.lose_gold( self.buy_price() )
    end

    # 
    def sell
      item = Event_Script::Sell_Actor_Select.item
      item = Event_Script::Sell_Actor_Select.weapon if item.nil?
      item = Event_Script::Sell_Actor_Select.armor if item.nil?
      actor = Event_Script::Sell_Actor_Select.actor
      if actor.nil?
        actor = $game_party
      end
      Item_Facade.throw_item(item,actor)
      $game_party.gain_gold(item.sell_price)
    end

    # EBhEJ
    def open(shop_goods)
      if @@window.nil?
        @@window = DQ::Window_Shop.new(shop_goods,Variables[PRICE_RATE_VARIABLE,100])
        @@window.visible = true
      end
      @@item = nil
    end

    # EBhE
    def close()
      if not @@window.disposed?
        @@window.dispose
      end
      @@window = nil
    end

    # EBhE̍XV
    def update()
      result = (@@window.nil? or @@window.disposed? or @@window.close?)
      if result
        if @@window.item.nil?
          @@item = nil
          @@price = 0
          Variables[CHOICE_VARIABLE] = -1
          Variables[PRICE_VARIABLE] = 0
        else
          @@item = @@window.item
          @@price = @@window.price(@@item)
          Variables[CHOICE_VARIABLE] = @@item.id
          Variables[PRICE_VARIABLE] = @@price
        end
        close()
      else
        @@window.update
      end
      return result
    end

    def item?
      return Item_Facade.item?(@@item)
    end

    def weapon?
      return Item_Facade.weapon?(@@item)
    end

    def armor?
      return Item_Facade.armor?(@@item)
    end

    def item
      return nil if not item?
      return @@item
    end

    def weapon
      return nil if not weapon?
      return @@item
    end

    def armor
      return nil if not armor?
      return @@item
    end

    # X̏iNAiACe̓Xj
    # name:: X̖O
    def clear_items(name)
      if $game_temp.generator_shop_goods.member?(name)
        $game_temp.generator_shop_goods[name].clear
      end
    end

    # ACe𔄂iACe̓Xj
    # {́Acommand_302 Ƃ
    # name:: X̖O
    # key_name:: ACeɎghc
    # count::@ACe̐
    def generate_items(name,key_name,count = rand(6) + rand(6) + 2)
      # ogftOZbg
      $game_temp.battle_abort = true
      # X̃ACe
      unless $game_temp.generator_shop_goods.member?(name)
        $game_temp.generator_shop_goods[name] = []
      end
      shop_goods = $game_temp.generator_shop_goods[name]
      if shop_goods.empty?
        # ACe@擾
        gt = Data_Loader.game_treasure
        for i in 0 .. count
          shop_items = gt.drop(key_name)
          shop_goods.concat(shop_items)
        end
      end
      shop_goods.sort!() do |a,b|
        r = b.type.id <=> a.type.id
        if r == 0
         r = a.id <=> b.id
        end
        r
      end
      open(shop_goods)
      return true
    end

    # X̃ACe炷BiACe̓Xj
    # name:: X̖O
    def lose_item(name)
      if $game_temp.generator_shop_goods.member?(name)
        $game_temp.generator_shop_goods[name].delete(@@item)
      end
      return true
    end
  end
end
